#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

extern void clkbegin(void);
extern void clkend(void);
extern int CLKcount;
extern float CLKclock;

void clkput(void){
	if(CLKcount){
		printf("ave =%9.2fclk(%dcounts)\n", CLKclock / CLKcount, CLKcount);
//		printf("time=%fsec\n", CLKclock / 700 * 1.0e-6);
	}
}

int test0(int a);
int test1(int a);
int test2(int a);
int test3(int a);
int test4(int a);
int test5(int a);
int test6(int a);
int test7(int a);

#define COUNT 10000

static int (*funcTbl[])() = {
	test0, test1, test2, test3, test4, test5, test6, test7,
	test0, test1, test2, test3, test4, test5, test6, test7,
};

void testR(int a){
	int i;
	clkbegin();
	for(i = 0; i < COUNT; i++){
		a = funcTbl[a](a);
		a = a & 15;
	}
	clkend();
	clkput();
}

void testR2(int a){
	int i;
	clkbegin();
	for(i = 0; i < COUNT; i++){
		a = funcTbl[a](a);
		a = a & 1;
	}
	clkend();
	clkput();
}

#define testD(num){\
	int i;\
	int a = num;\
	clkbegin();\
	for(i = 0; i < COUNT; i++){\
		a = funcTbl[a](a);\
		a = a % 1;\
	}\
	clkend();\
	clkput();\
}

#define TEST(num) puts(#num);CLKclock = 0;CLKcount = 0;testR(num);CLKclock = 0;CLKcount = 0;testR2(num)


int main(int argc, char *argv[]){
	TEST(0);
	TEST(1);
	TEST(2);
	TEST(3);
	TEST(4);
	TEST(5);
	TEST(6);
	TEST(7);

	return 0;
}
